#ifndef _HARK__BEAMFORMING__MSNR_H__INCLUDED_
#define _HARK__BEAMFORMING__MSNR_H__INCLUDED_ 1

#include "BF.h"

namespace BF
{
    class CMSNR : public BF
    {
    public:
	CMSNR(int numFreq, int lowerfreq, int upperfreq, int samplingRate, double soundSpeed, std::string decomp_alg, double alpha);
	virtual ~CMSNR();

    public:
	virtual BfType getBfAlgorithmType() const { return BfMSNR; }

	virtual void updateSources(const std::vector<SourceLocation> &sourcePositions);
	virtual void adaptSeparationMatrices();

    private:
	std::vector<Matrix> Rss; /* sizs_is(numSrc * numFreq), element_is(Matrix(numMic, numMic)) */
	std::vector<Matrix> Rnn; /* sizs_is(numSrc * numFreq), element_is(Matrix(numMic, numMic)) */
	std::vector<int> RssCnt; /* sizs_is(numSrc * numFreq) */
	std::vector<int> RnnCnt; /* sizs_is(numSrc * numFreq) */
	std::string decomp_alg;
	double alpha;
	int iniRnnFlag; // add

    };
}

#endif
